<template>
  <div>
    <div class="q-pa-md" style="max-width: 350px">
      <p>
        When pressing 'assign to teams', a team will be created for each
        breakout room with each attendee assigned as a member
      </p>
      <div>
        <q-btn @click="sendTeamName" label="Send Name Creation Prompt" />
      </div>
      <div class="headings">Submitted Names</div>
      <div>
        <q-list class="q-mb-sm table" bordered separator>
          <q-item
            style="align-items: center"
            v-for="(submission, id, index) in teamNames"
            :key="id"
          >
            <template v-if="!submission.approved">
              <q-item-section class="team-name">
                <q-item-label>{{ id }}</q-item-label>
              </q-item-section>
              <q-item-section class="submission">
                <q-item-label>{{
                  submission.name
                }}</q-item-label>
              </q-item-section>
              <q-item-section class="approve">
                <q-btn
                  @click="approveTeamName(id.toString(), submission.name)"
                  label="Approve Team Name"
                />
              </q-item-section>
              <q-item-section class="reject">
                <q-btn
                  @click="rejectTeamName(id.toString(), submission.name)"
                  label="Reject Team Name"
                />
              </q-item-section>
            </template>
          </q-item>
        </q-list>
      </div>
      <div class="headings">Approved Names</div>
      <div>
        <q-list class="q-mb-sm table" bordered separator>
          <q-item
            style="align-items: center"
            v-for="(submission, id, index) in teamNames"
            :key="id"
          >
            <template v-if="submission.approved">
              <q-item-section class="team-name">
                <q-item-label>{{ id }}</q-item-label>
              </q-item-section>
              <q-item-section class="submission">
                <q-item-label>{{ submission.name }}</q-item-label>
              </q-item-section>
            </template>
          </q-item>
        </q-list>
        <q-item-section class="finalise">
          <q-btn @click="finaliseTeamNames()" label="Finalise Team Names" />
        </q-item-section>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import {
  approveTeamName,
  rejectTeamName,
  sendNamingMessageToAllTeams,
  finaliseTeamNames,
} from "./teamNaming";
import { NameSubmissions } from "./types";
import { Teams } from "./team";
import {
  ZoomSenseClientFirebaseDB,
  //ZoomSenseConfigCurrentStatePlugins,
} from "@zoomsense/zoomsense-firebase";
import { typedVuefirePlugin } from "@zoomsense/zoomsense-firebase";
Vue.use(typedVuefirePlugin);
export default Vue.extend({
  name: "Dashboard",
  props: {
    firebase: {
      required: true,
      type: Object as () => ZoomSenseClientFirebaseDB,
    },
    context: {
      required: true,
      type: Object as () => { meetingid: string },
    },
  },
  data() {
    return {
      teamNames: undefined as undefined | NameSubmissions,
      teams: undefined as undefined | Teams,
    };
  },
  created() {
    console.log("Dashboard created");
  },
  methods: {
    async sendTeamName() {
      await sendNamingMessageToAllTeams(this.context.meetingid, this.firebase);
    },
    async approveTeamName(teamId: string, name: string) {
      await approveTeamName(
        this.context.meetingid,
        teamId,
        name,
        this.firebase
      );
    },
    async rejectTeamName(teamId: string, name: string) {
      await rejectTeamName(this.context.meetingid, teamId, name, this.firebase);
    },
    async finaliseTeamNames() {
      await finaliseTeamNames(
        this.context.meetingid,
        this.teams,
        this.firebase
      );
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        await this.$typedRtdbBind(
          "teamNames",
          this.firebase.ref(
            `/data/plugins/teamNaming/${this.context.meetingid}`
          )
        );
        await this.$typedRtdbBind(
          "teams",
          this.firebase.ref(
            `/data/plugins/teamPlugin/${this.context.meetingid}`
          )
        );
      },
    },
  },
});
</script>

<style>
.table{
  width: 1000px;
  overflow-wrap: anywhere;
}
.headings {
   font-size: xx-large;
   font-weight: bolder;
 }
</style>
